var http = require('http'), 
    https = require('https');

var urls = {
	http : 'http://www.google.com',
	https: 'https://www.google.com'
}

var make_request = function(protocol_name){

	var protocol = protocol_name == 'https' ? https : protocol_name == 'http' ? http : null;
	if(!protocol) console.log('Usage: ' + process.argv[0] + ' http|https') || process.exit(1);

	var uri = process.argv[3] || urls[protocol_name];
	var remote = require('url').parse(uri);

	var headers = {
		"Host": remote.hostname,
		"User-Agent": 'Foobar/2.3.4',
		"Connection": "close",
		"Accept": "*/*"
	}

	var opts = {
		host: remote.hostname,
		port: remote.port || (remote.protocol == 'https:' ? 443 : 80),
		path: remote.pathname + (remote.search || ''),
		method: 'GET',
		headers: headers
	};
	
	console.log(opts);

	var req = protocol.request(opts, function(res){

		res.on('data', function(data){
			console.log(data.toString());
		})

		res.on('end', function(){
			console.log('ended');
		})

	})

	req.on('error', function(err){
		console.log(err);
		// console.log(this.shouldKeepAlive);
		// console.log(this.finished);
	});
	
	req.end();

	console.log('request sent to ' + opts.host);
	
}

make_request(process.argv[2]);
